Status: Closed Start date:  
Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 5.1.0   

Description

This is quite the corner case but we had this issue occur with one client at Planio:

With Setting.parent_issue_priority == 'derived', while setting a projects' parent project to nil, several issues that belonged to now

inaccessible versions were updated in Issue.update_versions. In one case, this led to a situation where an issues' parent issue

priority was updated, before that parent issue was being processed in the loop in Issue.update_versions. The attempt to then set the

parent issues' version to nil later failed with a StaleObjectError due to the previous save from Issue#update_parent_attributes.

The attached patch against current master fixes that by catching the error and retrying once with a reloaded version of the issue. It

also contains a test case that reproduces the issue (with MySQL, at least - the bug only shows when the child issue is processed

before the parent in update_versions, so it depends on the order in which issues are fetched there)

Associated revisions

Revision 22279 - 2023-08-23 09:40 - Go MAEDA

Retry in case of stale issue during Issue.update_versions (#38820).

Patch by Jens Krämer.

History

#1 - 2023-07-12 12:41 - Go MAEDA

- Target version set to Candidate for next major release

#2 - 2023-08-11 07:31 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0

Setting the target version to 5.1.0.

#3 - 2023-08-23 09:40 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch. Thank you.

#4 - 2023-10-30 10:37 - Go MAEDA

- Subject changed from retry in case of stale issue during Issue.update_versions to Retry in case of stale issue during Issue.update_versions
